# -*- mode: rpm-spec; indent-tabs-mode: nil -*-
#========================================================================
%global debug_package %{nil}

%define    ldas_tools_cmake_ver 1.0.8
%define    ldas_tools_al_ver    2.6.3
%define    basename_            ldas-tools-al
%define    name                 %{basename_}-swig
%define    hdr_dir              ldastoolsal
%define    tarbasename          ldas-tools-al-swig
%define    version              2.6.7
%define    release              1
%define    _docdir              %{_datadir}/doc/%{name}-%{version}

#------------------------------------------------------------------------
# OS configuration
#------------------------------------------------------------------------
%if 0%{?rhel} != 0
%if 0%{?rhel} <= 7
%define cmake_package cmake3 >= 3.6, cmake
%endif

%if "%{__python3}" == "/usr/bin/python3"
%define ldas_python3_package_version_nodots 36
%endif
%if "%{__python3}" == "/usr/bin/python3.6"
%define ldas_python3_package_version_nodots 36
%endif
%if "%{__python3}" == "/usr/bin/python3.4"
%define ldas_python3_package_version_nodots 34
%endif

%if 0%{?__python3_other:1}
%define python3_package_version_nodots %{ldas_python3_package_version_nodots}
%endif

%if 0%{!?fedora:1}
%define python3_module_package_prefix python%{ldas_python3_package_version_nodots}
%endif

%endif # 0%{?rhel}

%if 0%{?centos:1}
%if 0%{?centos} <= 7
%define cmake_package cmake3 >= 3.6, cmake
%define swig_package swig3 >= 3.0.7
%endif
%endif

#------------------------------------------------------------------------
# Defaults
#------------------------------------------------------------------------
%if 0%{!?python3_pkgversion:1} != 0
%if 0%{?python3_version_nodots} != 0
%define python3_pkgversion %{python3_version_nodots}
%else
%define python3_pkgversion 36
%endif
%endif

%if 0%{!?python3_package_version_nodots:1}
%define python3_package_version_nodots %{python3_pkgversion}
%endif

%if 0%{!?python3_module_package_prefix:1}
%define python3_module_package_prefix python%{python3_pkgversion}
%endif

%if 0%{!?swig_package:1}
%define swig_package swig >= 3.0.7
%endif
%if 0%{!?cmake_package:1}
%define cmake_package cmake >= 3.6
%endif

%if %{?__python2:1}%{!?__ptyhon2:0}
%define    python_build_opts  -DENABLE_SWIG_PYTHON2=yes -DPYTHON2_EXECUTABLE=%{__python2}
%else
%define    python_build_opts  -DENABLE_SWIG_PYTHON2=NO
%endif
%if %{?__python3:1}%{!?__ptyhon3:0}
%define    python3_build_opts -DENABLE_SWIG_PYTHON3=YES -DPYTHON3_EXECUTABLE=%{__python3}
%else
%define    python_build_opts  -DENABLE_SWIG_PYTHON3=NO
%endif

%if %{?cmake3:1}%{!?cmake3:0}
%define cmake cmake3
%define ctest ctest3
%endif

#------------------------------------------------------------------------
Name:      %{name}
Summary:   LDAS tools abstraction toolkit language buildings
Version:   %{version}
Release:   %{release}%{?dist}
License:   GPLv2+
URL:       "https://wiki.ligo.org/Computing/LDASTools"
Group:     Application/Scientific
Provides:  %{name} = %{version}
Obsoletes: %{name} < %{version}
Conflicts: ldas-tools-al <= 2.6.1
Prefix:    %_prefix
BuildRoot: %{buildroot}
Source0:   http://software.ligo.org/lscsoft/source/%{tarbasename}-%{version}.tar.gz

#------------------------------------------------------------------------
BuildRequires: %{cmake_package}
BuildRequires: gawk
BuildRequires: gcc, gcc-c++, glibc
BuildRequires: make
BuildRequires: pkgconfig
BuildRequires: python3-rpm-macros
BuildRequires: rpm-build
BuildRequires: %{swig_package}
BuildRequires: ldas-tools-cmake >= %{ldas_tools_cmake_ver}
BuildRequires: %{basename_}-devel >= %{ldas_tools_al_ver}

#........................................................................
# Python dependencies
#........................................................................
BuildRequires: python
BuildRequires: python-devel
#........................................................................
# Python 3 dependencies
#........................................................................
BuildRequires: python%{python3_package_version_nodots}
BuildRequires: python%{python3_package_version_nodots}-devel
#........................................................................
# Runtime dependencies
#........................................................................
Requires: %{basename_}-devel

%description
This provides the runtime libraries for the abstaction library.

%if %{?__python2:1}%{!?__ptyhon2:0}
#========================================================================
%package -n python2-%{basename_}
Summary: LDAS Tools %{name_desc} toolkit python %{python_version} bindings
#........................................................................
# Runtime dependencies
#........................................................................
Requires: ldas-tools-al >= %{ldas_tools_al_ver}
Requires: python

%description -n  python2-%{basename_}
This provides the python%{python_version} bindings for the %{name_desc} library
%endif

#========================================================================
%package -n %{python3_module_package_prefix}-%{basename_}
Summary:   LDAS tools abstraction toolkit language buildings
#........................................................................
# Runtime dependencies
#........................................................................
Requires: ldas-tools-al >= %{ldas_tools_al_ver}
Requires: python%{python3_package_version_nodots}

%description -n  %{python3_module_package_prefix}-%{basename_}
This provides the runtime libraries for the abstaction library.

%prep
%setup -c -T -D -a 0 -n %{name}-%{version}

%cmake \
    %{python_build_opts} \
    %{python3_build_opts} \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo -DCMAKE_EXPORT_COMPILE_COMMANDS=1 \
    -DCMAKE_INSTALL_PREFIX=%{_prefix} \
    -DCMAKE_INSTALL_DOCDIR=%{_docdir} \
    %{tarbasename}-%{version}

%install
%__cmake --build . --target install -- DESTDIR=%{buildroot}

%check
%ctest -V %{?_smp_mflags}

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%{_includedir}/%{hdr_dir}/*.i

%if %{?__python2:1}%{!?__ptyhon2:0}
%files -n python2-%{basename_}
%defattr(-,root,root,-)
%{_libdir}/python2*
%endif

%files -n %{python3_module_package_prefix}-%{basename_}
%defattr(-,root,root,-)
%{_libdir}/python3*

%changelog
* Wed Aug 14 2019 Edward Maros <ed.maros@ligo.org> - 2.6.7-1
- Built for new release

* Tue Nov 27 2018 Edward Maros <ed.maros@ligo.org> - 2.6.5-1
- Built for new release

* Tue Oct 11 2011 Edward Maros <emaros@ligo.caltech.edu> - 1.19.13-1
- Initial build.
